program Himage

  use sep

  implicit none

  integer                              :: n1, n2, n3, k
  real                                 :: o1, d1, o2, d2, o3, d3, h
  real, dimension(:,:,:), allocatable  :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  allocate(data(n1,n2,n3))

  call sep_read(data)

  do k=1,n3
    h = o3 + (k-1)*d3
    data(:,:,k) = -data(:,:,k)*h*h
  end do

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call sep_write(data)

  call sep_close()
end program
