program Himage

  use sep

  implicit none

  integer                              :: n1, n2, i, depth
  real                                 :: o1, d1, o2, d2, vmin, vmax
  real, dimension(:,:), allocatable    :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  call from_param("depth", depth)
  call from_param("vmin", vmin)
  call from_param("vmax", vmax)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  allocate(data(n1,n2))

  data(1:depth,:) = vmin
  do i=depth,n1
    data(i,:) = 1.*(i-depth)/(n1-depth)*(vmax-vmin) + vmin
  enddo

  call sep_write(data)

  call sep_close()
end program
