program Himage

  use sep

  implicit none

  integer                              :: n1, n2, n3, j, k, tl
  real                                 :: o1, d1, o2, d2, o3, d3, wt
  real, dimension(:,:,:), allocatable  :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  allocate(data(n1,n2,n3))

  call sep_read(data)

  tl=n2/5

  do j=1,tl
    wt=1.*j/tl
    data(:,j,:) = data(:,j,:)*wt
  end do

  do j=n2-tl+1,n2
    wt=(n2-j+1.)/tl
    data(:,j,:) = data(:,j,:)*wt
  end do

  tl=n3/5

  do k=1,tl
    wt=1.*k/tl
    data(:,:,k) = data(:,:,k)*wt
  end do

  do k=n3-tl+1,n3
    wt=(n3-k+1.)/tl
    data(:,:,k) = data(:,:,k)*wt
  end do

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call sep_write(data)

  call sep_close()
end program
