#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int c_setdevice_(int *gpu_id)
{
  gpu_setdevice(gpu_id);
  return (1);
}

int c_init1_(int *nt, int *n1, int *n2, int *n3, float *dt, float *d1, float *d2)
{
  gpu_init1(nt, n1, n2, n3, dt, d1, d2);
  return (1);
}

int c_init2_(int *h_nx, int *h_ox, int *n1e, int *n2e, int *bc1, int *bc2, int *wfld_j)
{
  gpu_init2(h_nx, h_ox, n1e, n2e, bc1, bc2, wfld_j);
  return (1);
}

int c_init3_(int *sou_nx, int *sou_ox, int *sou_dx, int *sou_z, int *rec_nx, int *rec_ox, int *rec_dx, int *rec_z)
{
  gpu_init3(sou_nx, sou_ox, sou_dx, sou_z, rec_nx, rec_ox, rec_dx, rec_z);
  return (1);
}

int c_alloc_()
{
  gpu_alloc();
  return (1);
}

int c_model_update_(float *velsq, float *vwt, float *wt)
{
  gpu_model_update(velsq, vwt, wt);
  return (1);
}

int c_source_update_(float *source)
{
  gpu_source_update(source);
  return (1);
}

int c_nlmodel_(int *tid, int *nth, float *data)
{
  gpu_nlmodel(tid, nth, data);
  return (1);
}

int c_model_(int *tid, int *nth, float *deltaV, float *data)
{
  gpu_model(tid, nth, deltaV, data);
  return (1);
}

int c_migrate_(int *tid, int *nth, float *deltaV, float *data)
{
  gpu_migrate(tid, nth, deltaV, data);
  return (1);
}
