program Himage

  use sep

  implicit none

  integer                          :: n1
  real                             :: o1, d1
  real, dimension(:), allocatable  :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)

  allocate(data(n1))
  call sep_read(data)

  data = data/maxval(data)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)

  call sep_write(data)

  call sep_close()
end program
